<?php

$tableName = "phpMySearch_stats";

class Statistics
{
	var $quant;
	var $link;
	var $DBName;
	var $host;
	var $user;
	var $password;
	var $structTableName;
	var $errMess;
	var $log;

	//		**********************************************************************
	//		******************** FUNCTION statistics() ***************************
	//		*** this is the constructor of the class statistics and it creates ***
	//		*** a connection to the database - being the constructor it is *******
	//		*** possible to make the connection when the class is instantiated ***
	//		**********************************************************************

	function statistics($DBName, $host, $user, $password)
		{
			global $SearchEngineConst;

			$this->link = mysql_connect($host, $user, $password);
			if($this->link > 0)
				{
					if(!mysql_select_db($DBName, $this->link))
					{
						$this->log->error(sprintf($SearchEngineConst['BadQueryErrMsg'],$query,mysql_error($this->link)));
						$this->log->error($errMess);
					}
				}
			else
				{
					$this->setErrMess(sprintf($SearchEngineConst['SelectDBErrMsg'],$query,mysql_error($this->link)));
					$this->log->error($errMess);
				}
		}
	//		*******************************************************************
	//		******************** FUNCTION input() *****************************
	//		*** $result checks all entered terms from phpmysearch_stats *******
	//		*** and ends if there does not occur any error or goes on *********
	//		*** $numRows checks how many entries exist - if the entered *******
	//		*** term does not exist it is inserted and sets quantity to 1 *****
	//		*** if it already exists the quantity is counted up by 1 and if ***
	//		*** there are errors they are reported to function logError()******
	//		*** returns the quantity ******************************************
	//		*******************************************************************
	function input($search)
		{

		global		$tableName;
		global		$SearchEngineConst;
		
		$this->adminConfig = &AdminConfigInstance();
		$this->log = &LogInstance($this->adminConfig->param("searchEngineLogFileName"));
		$this->log->start($SearchVisualizerConst['StartSearchEngineMsg']);

		$query =<<<END
SELECT * FROM $tableName WHERE word = '$search'
END;
			$result =	mysql_query($query);
			if(!$result)
			{
				$this->log->error(sprintf($SearchEngineConst['BadQueryErrMsg'],$query,mysql_error($this->link)));
				$this->log->error($errMess);
			}
			else
				{
					$dbErg = mysql_fetch_array($result);
					$this->quant = $dbErg["quantity"];

					$numRows = mysql_num_rows($result);
					//	insertion of non-existing terms
					if(!$numRows)
						{
							$this->quant = 1;
							$query =<<<END
INSERT INTO $tableName(word,quantity) VALUES('$search','$this->quant')
END;
							$insert = mysql_query($query);
							if(!$insert)
							{
								$this->log->error(sprintf($SearchEngineConst['BadQueryErrMsg'],$query,mysql_error($this->link)));
								$this->log->error($errMess);
							}
						}
						else
						{
							//	update of existing terms
							if($this->quant > 0)
							{
								$this->quant = $this->quant + 1;
								$query =<<<END
UPDATE $tableName SET
quantity = '$this->quant'
WHERE word = '$search'
END;
								$update = mysql_query($query);
								if(!$update)
								{
									$this->log->error(sprintf($SearchEngineConst['BadQueryErrMsg'],$query,mysql_error($this->link)));
									$this->log->error($errMess);
								}
							}
						}
					}
				return $this->quant;
				}

	//		*******************************************************************
	//		******************** FUNCTION percentage() ************************
	//		*** gets word and quantity from phpmysearch_stats and the sum *****
	//		*** of all entries uses while-loop to calculate every percentage **
	//		*** of every entry updates phpmysearch_stats returns the update ***
	//		*******************************************************************

	function percentage($num, $add)
	{
        	global $tableName;
		global $SearchEngineConst;

		$query =<<<END
SELECT word, quantity FROM $tableName
END;
		$searchNum = mysql_query($query);

		if(!$searchNum)
		{
			$this->log->error(sprintf($SearchEngineConst['BadQueryErrMsg'],$query,mysql_error($this->link)));
			$this->log->error($errMess);
		}

		$query =<<<END
SELECT SUM(quantity) AS sum FROM $tableName
END;
		$sum = mysql_query($query);
		if(!$sum)
		{
			$this->log->error(sprintf($SearchEngineConst['BadQueryErrMsg'],$query,mysql_error($this->link)));
			$this->log->error($errMess);
		}

		$result = mysql_fetch_array($sum);

		//	loop(where to put each percentage)
		while($output = @mysql_fetch_array($searchNum))
			{
				//	calculation, calibration and update of percentage
				$calc = $output["quantity"] / $result["sum"] * 100;
				$perCent = sprintf ("%01.2f", $calc);
				$query =<<<END
UPDATE $tableName SET percentage = '$perCent' WHERE word = '$output[word]'
END;
				$res = mysql_query($query);
				if(!$res)
				{
					$this->log->error(sprintf($SearchEngineConst['BadQueryErrMsg'],$query,mysql_error($this->link)));
					$this->log->error($errMess);
				}
			}
			return $res;
		}		//		end percentage()

  //		***************************************************************
  //		******************** FUNCTION errMess() ***********************
  //    *** definition of the error messages **************************
  //		***************************************************************

	function errMess()
	{
		return($this->errMess);
	}

  //		***************************************************************
  //		******************** FUNCTION setErrMess() ********************
  //    *** defines which error message will be shown *****************
  //		***************************************************************

	function setErrMess($errMess)
	{
		$this->errMess = $errMess;
	}


  //		***************************************************************
  //		******************** FUNCTION clearTable() ********************
  //		*** allows admin to clear $table_stats if wanted to ***********
  //		***************************************************************

	function clearStatsTable()
	{
		global $tableName;
		global $SearchEngineConst;

		$query =<<<END
DELETE FROM $tableName;
END;
		if (!mysql_query($query,$this->link))
		{
			$this->log->error(sprintf($SearchEngineConst['BadQueryErrMsg'],$query,mysql_error($this->link)));
			$this->log->error($errMess);
		}
	}

	//		*******************************************************************
	//		******************** Ends mysql-session ***************************
	//		*******************************************************************

  	function disconnect()
  	{
    		mysql_close($this->link);
   	}

}
?>
